#include <fcntl.h>
#include <io.h>
#include <stdlib.h>
#include <windows.h>
#include <sys\stat.h>
#include <stdio.h>

#include "WZip.hpp"


// global variables instancied in gzip 
extern "C" 
{
    extern int dozip( int, int);
    extern int dounzip( int, int );
    extern long time_stamp;
    extern char ifname[MAX_PATH]; 
    extern int save_orig_name;

    extern int ifd;
    extern int ofd;
}


int inFile, outFile;


// this function is called by gzip when there is an error
// instead of doing an exit( .. )
extern "C" void do_exit_dll(int exitcode)
{
    close( inFile );
    close( outFile );
}


static WBool Hardword( WBool zip_file, WFilePath &source, WFilePath &destination )
{
    if( source == destination )
        return FALSE;
    
    // try to open in unzipped file
    inFile = open( source.GetText(), _O_BINARY | _O_RDONLY );
    if( inFile == -1 )
        return FALSE;
    
    outFile = open( destination.GetText(), _O_BINARY | _O_RDWR | _O_CREAT | _O_EXCL); // , _S_IREAD | _S_IWRITE  );
    if( outFile == -1 )
    {
        close(inFile);
        return FALSE;
    }
    
    ifd=inFile; ofd=outFile;
    
    WBool ret;
    if( zip_file )
        ret = dozip( inFile, outFile );
    else
        ret = dounzip( inFile, outFile );
    
    close( inFile );
    close( outFile );
    
    if (ret != 0)
        return FALSE;
    
    return TRUE;
}

WBool WZip( WFilePath originalfile, WFilePath zipfile )
{
    return Hardword( TRUE, originalfile, zipfile );
}

WBool WUnZip( WFilePath zipfile, WFilePath originalfile )
{
    return Hardword( FALSE, zipfile, originalfile );
}




















